#ifndef	V_STROKE_H
#define	V_STROKE_H

/*
 *	Support for arrays of polylines. To use by v_gfont.c.
 */

typedef struct	mesh_stroke_s
{
	u32_t		num_coords;
    vec3_t		coords[1];			/* variable sized */
}	mesh_stroke_t, *mesh_stroke_p;

#ifndef	GL_VERTEX3V
#ifdef	DOUBLEVEC
#define	GL_VERTEX3V	glVertex3dv
#else	/* !DOUBLEVEC */
#define	GL_VERTEX3V	glVertex3fv
#endif	/* !DOUBLEVEC */
#endif	/* !GL_VERTEX3V */

#define	DRAW_STROKE(stroke) { \
			u32_t i,len=(stroke).num_coords; \
            glBegin(GL_LINE_STRIP); \
			for(i=0;i<len;i++) \
				GL_VERTEX3V((stroke).coords[i]); \
			glEnd(); \
		}
        
typedef	void_p		mesh_strokes_t;

#ifdef	__cplusplus
extern	"C" {
#endif		/* __cplusplus */
	/* Constructor and destructor */
	mesh_strokes_t	V_GLOBAL	meshCreateStrokes(void);
    void	V_GLOBAL	meshDeleteStrokes(mesh_strokes_t ms);
    /* Methods for creation of glyphs */
	void	V_GLOBAL	meshStrokeCoord(mesh_strokes_t ms,
    	vec_t x,vec_t y,vec_t z);
	void	V_GLOBAL	meshStrokeCoordv(mesh_strokes_t ms,vec3_t xyz);
	void	V_GLOBAL	meshEndStroke(mesh_strokes_t ms);
	void	V_GLOBAL	meshCancelStroke(mesh_strokes_t ms);
	void	V_GLOBAL	meshEndGlyph(mesh_strokes_t ms);
	void	V_GLOBAL	meshCancelGlyph(mesh_strokes_t ms);
	/* Returns number of complete glyphs */
	u32_t	V_GLOBAL	meshGlyphCount(mesh_strokes_t ms);
	/* Returns number of complete strokes for uncomplete glyph */
	u32_t	V_GLOBAL	meshStrokesCount(mesh_strokes_t ms,
    	u32_t glyph_num);
	/* Returns stroke 'stroke_num' of glyph 'glyph_num' */
    mesh_stroke_p	V_GLOBAL meshGlyphStroke(mesh_strokes_t ms,
    	u32_t glyph_num,u32_t stroke_num);
#ifdef	__cplusplus
}
#endif		/* __cplusplus */

#endif	/* V_STROKE_H */
